//spaceMeter64
// Copyright (C) 2019-2020 D.Blanchemain
// ---------------------------------------------------------------------
//This application is free software; you can redistribute it
// and/or modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 3 of
// the License, or (at your option) any later version.
 
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
 
 //You should have received a copy of the GNU General Public License
 // along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 /************************************************************************
 ************************************************************************
 FAUST API Architecture File
 Copyright (C) 2016 GRAME, Romain Michon, CCRMA - Stanford University
 Copyright (C) 2014-2017 GRAME, Centre National de Creation Musicale
 Dbmeter license : BSD
 ---------------------------------------------------------------------
*/
#include <SFML/Graphics.hpp>
#include <iostream>
#include <stdlib.h>
#include "DspFaust.h"

using namespace std;
int main()
{
	 float enc[64][3];
    const char* encAdd[64];
	 enc[0][0]=258;
	 enc[0][1]=222;
	 enc[0][2]=-76;
	 enc[1][0]=356;
	 enc[1][1]=222;
	 enc[1][2]=-76;
	 enc[2][0]=307;
	 enc[2][1]=222;
	 enc[2][2]=-76;
	 enc[3][0]=182;
	 enc[3][1]=222;
	 enc[3][2]=-76;
	 enc[4][0]=420;
	 enc[4][1]=222;
	 enc[4][2]=-76;	 
	 enc[5][0]=82;
	 enc[5][1]=222;
	 enc[5][2]=-76;
	 enc[6][0]=532;
	 enc[6][1]=222;
	 enc[6][2]=-76;
	 enc[7][0]=208;
	 enc[7][1]=222;
	 enc[7][2]=-76;
	 enc[8][0]=394;
	 enc[8][1]=222;
	 enc[8][2]=-76;
	 enc[9][0]=140;
	 enc[9][1]=222;
	 enc[9][2]=-76;
	 enc[10][0]=480;
	 enc[10][1]=222;
	 enc[10][2]=-76;
	 enc[11][0]=12;
	 enc[11][1]=222;
	 enc[11][2]=-76;
	 enc[12][0]=596;
	 enc[12][1]=222;
	 enc[12][2]=-76;
	 enc[13][0]=208;
	 enc[13][1]=298;
	 enc[13][2]=-76;
	 enc[14][0]=394;
	 enc[14][1]=298;
	 enc[14][2]=-76;
	 enc[15][0]=256;
	 enc[15][1]=298;
	 enc[15][2]=-76;
	 enc[16][0]=358;
	 enc[16][1]=298;
	 enc[16][2]=-76;
	 enc[17][0]=307;
	 enc[17][1]=298;
	 enc[17][2]=-76;
	 enc[18][0]=208;
	 enc[18][1]=158;
	 enc[18][2]=-76;
	 enc[19][0]=394;
	 enc[19][1]=158;
	 enc[19][2]=-76;
	 enc[20][0]=258;
	 enc[20][1]=158;
	 enc[20][2]=-76;
	 enc[21][0]=352;
	 enc[21][1]=158;
	 enc[21][2]=-76;
	 enc[22][0]=308;
	 enc[22][1]=158;
	 enc[22][2]=-76;
	 enc[23][0]=16;
	 enc[23][1]=432;
	 enc[23][2]=-76;
	 enc[24][0]=590;
	 enc[24][1]=432;
	 enc[24][2]=-76;
	 enc[25][0]=82;
	 enc[25][1]=384;
	 enc[25][2]=-76;
	 enc[26][0]=532;
	 enc[26][1]=398;
	 enc[26][2]=-76;
	 enc[27][0]=136;
	 enc[27][1]=346;
	 enc[27][2]=-76;
	 enc[28][0]=478;
	 enc[28][1]=358;
	 enc[28][2]=-76;
	 enc[29][0]=182;
	 enc[29][1]=310;
	 enc[29][2]=-76;
	 enc[30][0]=420;
	 enc[30][1]=316;
	 enc[30][2]=-76;
	 enc[31][0]=16;
	 enc[31][1]=22;
	 enc[31][2]=-76;
	 enc[32][0]=592;
	 enc[32][1]=18;
	 enc[32][2]=-76;
	 enc[33][0]=82;
	 enc[33][1]=64;
	 enc[33][2]=-76;
	 enc[34][0]=532;
	 enc[34][1]=55;
	 enc[34][2]=-76;
	 enc[35][0]=138;
	 enc[35][1]=106;
	 enc[35][2]=-76;
	 enc[36][0]=478;
	 enc[36][1]=96;
	 enc[36][2]=-76;
	 enc[37][0]=182;
	 enc[37][1]=138;
	 enc[37][2]=-76;
	 enc[38][0]=420;
	 enc[38][1]=136;
	 enc[38][2]=-76;
	 enc[39][0]=178;
	 enc[39][1]=446;
	 enc[39][2]=-76;
	 enc[40][0]=450;
	 enc[40][1]=446;
	 enc[40][2]=-76;
	 enc[41][0]=308;
	 enc[41][1]=446;
	 enc[41][2]=-76;
	 enc[42][0]=184;
	 enc[42][1]=266;
	 enc[42][2]=-76;
	 enc[43][0]=440;
	 enc[43][1]=266;
	 enc[43][2]=-76;
	 enc[44][0]=308;
	 enc[44][1]=266;
	 enc[44][2]=-76;
	 enc[45][0]=180;
	 enc[45][1]=10;
	 enc[45][2]=-76;
	 enc[46][0]=450;
	 enc[46][1]=10;
	 enc[46][2]=-76;
	 enc[47][0]=306;
	 enc[47][1]=10;
	 enc[47][2]=-76;
	 enc[48][0]=236;
	 enc[48][1]=364;
	 enc[48][2]=-76;
	 enc[49][0]=378;
	 enc[49][1]=364;
	 enc[49][2]=-76;
	 enc[50][0]=308;
	 enc[50][1]=364;
	 enc[50][2]=-76;
	 enc[51][0]=250;
	 enc[51][1]=342;
	 enc[51][2]=-76;
	 enc[52][0]=308;
	 enc[52][1]=342;
	 enc[52][2]=-76;
	 enc[53][0]=368;
	 enc[53][1]=342;
	 enc[53][2]=-76;
	 enc[54][0]=256;
	 enc[54][1]=326;
	 enc[54][2]=-76;
	 enc[55][0]=358;
	 enc[55][1]=326;
	 enc[55][2]=-76;
	 enc[56][0]=308;
	 enc[56][1]=326;
	 enc[56][2]=-76;
	 enc[57][0]=276;
	 enc[57][1]=84;
	 enc[57][2]=-76;
	 enc[58][0]=330;
	 enc[58][1]=84;
	 enc[58][2]=-76;
	 enc[59][0]=260;
	 enc[59][1]=112;
	 enc[59][2]=-76;
	 enc[60][0]=340;
	 enc[60][1]=112;
	 enc[60][2]=-76;
	 enc[61][0]=302;
	 enc[61][1]=106;
	 enc[61][2]=-76;
	 enc[62][0]=284;
	 enc[62][1]=126;
	 enc[62][2]=-76;
	 enc[63][0]=324;
	 enc[63][1]=126;
	 enc[63][2]=-76;

    encAdd[0]="/Meter/0/0x56447ad09bb0";
    encAdd[1]="/Meter/1/0x56447ad0e980";
    encAdd[10]="/Meter/10/0x56447ad3c5c0";
	 encAdd[11]="/Meter/11/0x56447ad41480";
	 encAdd[12]="/Meter/12/0x56447ad46420";
	 encAdd[13]="/Meter/13/0x56447ad4b490";
	 encAdd[14]="/Meter/14/0x56447ad505e0";
	 encAdd[15]="/Meter/15/0x56447ad55810";
	 encAdd[16]="/Meter/16/0x56447ad5ab30";
	 encAdd[17]="/Meter/17/0x56447ad5ff30";
	 encAdd[18]="/Meter/18/0x56447ad65410";
	 encAdd[19]="/Meter/19/0x56447ad6a9c0";
	 encAdd[2]="/Meter/2/0x56447ad13750";
	 encAdd[20]="/Meter/20/0x56447ad70050";
	 encAdd[21]="/Meter/21/0x56447ad758a0";
	 encAdd[22]="/Meter/22/0x56447ad7b1e0";
	 encAdd[23]="/Meter/23/0x56447ad80c00";
	 encAdd[24]="/Meter/24/0x56447ad86700";
	 encAdd[25]="/Meter/25/0x56447ad8c2d0";
 	 encAdd[26]="/Meter/26/0x56447ad91f80";
	 encAdd[27]="/Meter/27/0x56447ad97d10";
	 encAdd[28]="/Meter/28/0x56447ad9db90";
	 encAdd[29]="/Meter/29/0x56447ada3af0";
	 encAdd[3]="/Meter/3/0x56447ad18610";
	 encAdd[30]="/Meter/30/0x56447ada9b30";
	 encAdd[31]="/Meter/31/0x56447adafd20";
	 encAdd[32]="/Meter/32/0x56447adb5ff0";
	 encAdd[33]="/Meter/33/0x56447adbc3b0";
	 encAdd[34]="/Meter/34/0x56447adc2850";
	 encAdd[35]="/Meter/35/0x56447adc8dd0";
	 encAdd[36]="/Meter/36/0x56447adcf420";
	 encAdd[37]="/Meter/37/0x56447add5b50";
	 encAdd[38]="/Meter/38/0x56447addc370";
	 encAdd[39]="/Meter/39/0x56447ade2c70";
    encAdd[4]="/Meter/4/0x56447ad1d5b0";
	 encAdd[40]="/Meter/40/0x56447ade9650";
	 encAdd[41]="/Meter/41/0x56447adf01e0";
	 encAdd[42]="/Meter/42/0x56447adf6e50";
	 encAdd[43]="/Meter/43/0x56447adfdbc0";
	 encAdd[44]="/Meter/44/0x56447ae04a00";
	 encAdd[45]="/Meter/45/0x56447ae0b920";
	 encAdd[46]="/Meter/46/0x56447ae12910";
	 encAdd[47]="/Meter/47/0x56447ae199e0";
	 encAdd[48]="/Meter/48/0x56447ae20ba0";
	 encAdd[49]="/Meter/49/0x56447ae27e40";
	 encAdd[5]="/Meter/5/0x56447ad22630";
	 encAdd[50]="/Meter/50/0x56447ae2f1b0";
	 encAdd[51]="/Meter/51/0x56447ae366e0";
	 encAdd[52]="/Meter/52/0x56447ae3dd00";
	 encAdd[53]="/Meter/53/0x56447ae45400";
	 encAdd[54]="/Meter/54/0x56447ae4cbe0";
	 encAdd[55]="/Meter/55/0x56447ae54490";
	 encAdd[56]="/Meter/56/0x56447ae5be20";
	 encAdd[57]="/Meter/57/0x56447ae638a0";
	 encAdd[58]="/Meter/58/0x56447ae6b400";
	 encAdd[59]="/Meter/59/0x56447ae73030";
	 encAdd[6]="/Meter/6/0x56447ad27780";
	 encAdd[60]="/Meter/60/0x56447ae7ad40";
	 encAdd[61]="/Meter/61/0x56447ae82c20";
	 encAdd[62]="/Meter/62/0x56447ae8abe0";
	 encAdd[63]="/Meter/63/0x56447ae92c70";
	 encAdd[7]="/Meter/7/0x56447ad2c9b0";
	 encAdd[8]="/Meter/8/0x56447ad31cc0";
	 encAdd[9]="/Meter/9/0x56447ad370e0";
        
    // Create the main window
    sf::RenderWindow window(sf::VideoMode(601, 451), "spaceMeter64");
    
    // Load a sprite to display
    sf::Texture image;
    if (!image.loadFromFile("./images/volume.png"))
        return EXIT_FAILURE;
    sf::Sprite bkgimage(image);
    sf::Texture texture1;
    if (!texture1.loadFromFile("./images/g4971.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite1(texture1);
    sf::Texture texture2;
    if (!texture2.loadFromFile("./images/path4488.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite2(texture2);
    sf::Texture texture3;
    if (!texture3.loadFromFile("./images/path4487.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite3(texture3);
    sf::Texture texture4;
    if (!texture4.loadFromFile("./images/path4486.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite4(texture4);
    sf::Texture texture5;
    if (!texture5.loadFromFile("./images/path4489.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite5(texture5);
    sf::Texture texture6;
    if (!texture6.loadFromFile("./images/path4490.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite6(texture6);
    sf::Texture texture7;
    if (!texture7.loadFromFile("./images/path4485.png"))
        return EXIT_FAILURE;
    sf::Sprite sprite7(texture7);
    
    // Load a music to play
    DspFaust *dspFaust = new DspFaust();
    dspFaust->start();
    cout << "Faust is Running =" << dspFaust->isRunning()<< endl;
    // Start the game loop
    while (window.isOpen()){
        // Process events
        sf::Event event;
        while (window.pollEvent(event))
        {
            // Close window: exit
            if (event.type == sf::Event::Closed){
            	 dspFaust->stop();
	             cout << "Faust is Running =" << dspFaust->isRunning()<< endl;
                window.close();
            }  
        }
        // Clear screen
        window.clear();
        window.draw(bkgimage);
        
       
       for(int i=0;i<64;i++){
        enc[i][2]=dspFaust->getParamValue(encAdd[i]);
 
      if (enc[i][2]<-50){
  			  sprite1.setPosition(sf::Vector2f(enc[i][0]-2, enc[i][1]-2));
  			  window.draw(sprite1);
  		}
  		if (enc[i][2]>-50 && enc[i][2]<-40){
  			  sprite2.setPosition(sf::Vector2f(enc[i][0]-15, enc[i][1]-15));
  			  window.draw(sprite2);
  		}
  		if (enc[i][2]>-40 && enc[i][2]<-35){
  			  sprite3.setPosition(sf::Vector2f(enc[i][0]-20, enc[i][1]-20));
  			  window.draw(sprite3);
  		}
  		if (enc[i][2]>-35 && enc[i][2]<-25){
  			  sprite4.setPosition(sf::Vector2f(enc[i][0]-25, enc[i][1]-25));
  			  window.draw(sprite4);
  		}
  		if (enc[i][2]>-25 && enc[i][2]<-20){
  			  sprite5.setPosition(sf::Vector2f(enc[i][0]-35, enc[i][1]-35));
  			  window.draw(sprite5);
  		}
  		if (enc[i][2]>-20 && enc[i][2]<-10){
  			  sprite6.setPosition(sf::Vector2f(enc[i][0]-45, enc[i][1]-45));
           window.draw(sprite6);
  		}
  		if (enc[i][2]>-10){
  			 sprite7.setPosition(sf::Vector2f(enc[i][0]-64, enc[i][1]-64));
  			 window.draw(sprite7);
  		}
      } 
      window.display();
 
    }
    return EXIT_SUCCESS;
}
